<template>
  <div class="app-container">
    <el-form ref="dataForm" :model="dataForm" label-width="100px">
      <el-form-item label="主目錄" prop="oneTierMenu">
        <el-select v-model="dataForm.oneTierMenu" @change="getChildrenMenu(1)">
          <el-option v-for="(i,index) in oneTierMenus" :key="index" :label="i.title" :value="i.id" />
        </el-select>
      </el-form-item>
      <el-form-item label="次目錄" prop="twoTierMenu">
        <el-select v-model="dataForm.twoTierMenu" @change="getChildrenMenu(2)">
          <el-option v-for="(i,index) in twoTierMenus" :key="index" :label="i.title" :value="i.id" />
        </el-select>
      </el-form-item>
      <el-form-item label="次次目錄" prop="threeTierMenu">
        <el-select v-model="dataForm.threeTierMenu">
          <el-option
            v-for="(i,index) in threeTierMenus"
            :key="index"
            :label="i.title"
            :value="i.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="queryAction">查詢</el-button>
        <el-button @click="sortAction">更新排序</el-button>
        <el-button @click="resetAction">重置</el-button>
      </el-form-item>
    </el-form>
    <el-divider />
    <el-table :data="dataTable">
      <el-table-column label="標題" prop="title" />
      <el-table-column label="路徑" prop="id" />
      <el-table-column label="ICON" prop="icon">
        <template slot-scope="scope">
          <svg-icon :icon-class="scope.row.icon" />
        </template>
      </el-table-column>
      <el-table-column fixed="right" width="100" label="排序">
        <template slot-scope="scope">
          <el-button type="text" size="small" @click="upAction(scope.$index,scope.row)">UP</el-button>
          <el-button type="text" size="small" @click="downAction(scope.$index,scope.row)">down</el-button>
        </template>
      </el-table-column>
      <el-table-column fixed="left" width="100" label="編輯">
        <template slot-scope="scope">
          <el-button type="text" size="small" @click="dialogAction(scope.row)">編輯</el-button>
        </template>
      </el-table-column>
    </el-table>

    <el-dialog title="編輯路徑" :visible.sync="dialogFormVisible" :close-on-click-modal="false">
      <el-form :model="dataDialog" label-width="100px">
        <el-form-item label="路徑" prop="path">
          <el-input v-model="dataDialog.path" disabled />
        </el-form-item>
        <el-form-item label="標題">
          <el-input v-model="dataDialog.title" />
        </el-form-item>
        <el-form-item label="ICON" prop="icon">
          <el-select v-model="dataDialog.icon">
            <el-option v-for="(i,index) in iconItems.icons" :key="index" :label="i" :value="i">
              <span style="float: left">{{ i }}</span>
              <span style="float: right;">
                <svg-icon :icon-class="i" />
              </span>
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogDeleteAction">刪除</el-button>
        <el-button @click="dialogUpdateAction">更新</el-button>
        <el-button @click="recoveryAction">復原</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import {
  getOneTierMenu,
  getMenuByParent,
  getPathByParent,
  updateSort,
  updatePath,
  deletePath
} from './action'
import { iconItems } from './entity'
export default {
  data() {
    return {
      iconItems: iconItems(),
      dataForm: {
        oneTierMenu: '',
        twoTierMenu: '',
        threeTierMenu: ''
      },
      oneTierMenus: [],
      twoTierMenus: [],
      threeTierMenus: [],
      dataTable: [],
      originDataDialog: [],
      dataDialog: [],
      dialogFormVisible: false
    }
  },
  mounted() {
    this.getOneTierMenu()
  },
  methods: {
    dialogDeleteAction: function() {
      deletePath(this.dataDialog.id).then(res => {
        if (res.status === 'OK') {
          alert('刪除成功!')
          this.queryAction()
        } else {
          alert('刪除失敗!')
        }
      })
    },
    dialogUpdateAction: function() {
      updatePath(this.dataDialog).then(res => {
        if (res.status === 'OK') {
          alert('更新成功!')
          this.queryAction()
        } else {
          alert('更新失敗!')
        }
      })
    },
    recoveryAction: function() {
      this.dataDialog = Object.assign({}, this.originDataDialog)
      console.log(this.dataDialog)
    },
    dialogAction: function(row) {
      this.dataDialog = Object.assign({}, row)
      this.originDataDialog = Object.assign({}, row)
      this.dialogFormVisible = true
    },
    sortAction: function() {
      var ids = []

      for (var i = 0; i < this.dataTable.length; i++) {
        ids[i] = this.dataTable[i].id
      }

      updateSort(ids).then(res => {
        if (res.status === 'OK') {
          alert('更新排序成功!')
          this.queryAction()
        }
      })
    },
    upAction: function(index, row) {
      if (index > 0) {
        const temp = Object.assign({}, this.dataTable[index - 1])
        this.dataTable.splice(index - 1, 1, row)
        this.dataTable[index] = temp
      } else {
        alert('已經是第一了')
      }
    },
    downAction: function(index, row) {
      if (index < this.dataTable.length - 1) {
        const temp = Object.assign({}, this.dataTable[index + 1])
        this.dataTable.splice(index + 1, 1, row)
        this.dataTable[index] = temp
      } else {
        alert('已經是最後一個了')
      }
    },
    queryAction: function() {
      getPathByParent(this.dataForm).then(res => {
        if (res.status === 'OK') {
          this.dataTable = res.data
        }
      })
    },
    resetAction: function() {
      this.$refs.dataForm.resetFields()
      this.twoTierMenus = []
      this.threeTierMenus = []
      this.dataTable = []
    },
    getChildrenMenu: function(val) {
      if (val === 1) {
        this.twoTierMenus = []
        this.threeTierMenus = []
        this.dataForm.twoTierMenu = ''
        this.dataForm.threeTierMenu = ''
        getMenuByParent({ parent: this.dataForm.oneTierMenu, tier: 1 }).then(
          res => {
            if (res.status === 'OK') {
              this.twoTierMenus = res.data
            }
          }
        )
      } else if (val === 2) {
        this.threeTierMenus = []

        this.dataForm.threeTierMenu = ''
        getMenuByParent({ parent: this.dataForm.twoTierMenu, tier: 2 }).then(
          res => {
            if (res.status === 'OK') {
              this.threeTierMenus = res.data
            }
          }
        )
      }
    },
    getOneTierMenu: function() {
      getOneTierMenu().then(res => {
        if (res.status === 'OK') {
          this.oneTierMenus = res.data
        }
      })
    }
  }
}
</script>

